Bug 431559 - Circular build dependency
Circular build dependency
Status: CLOSED NOTABUG
Product: Fedora
Classification: Fedora
Component: perl-Params-Util (Show other bugs)
9
All Linux
low Severity low
: ---
: ---
Assigned To: Ralf Corsepius
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-02-05 09:04 EST by Ed Avis
Modified: 2009-06-12 11:40 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-06-12 11:40:04 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Ed Avis 2008-02-05 09:04:46 EST
Building perl-PPI needs perl-Params-Util.
Building perl-Params-Util needs perl-Test-MinimumVersion.
Building perl-Test-MinimumVersion needs perl-Perl-MinimumVersion.
Building perl-Perl-MinimumVersion needs perl-PPI.

I suggest breaking the chain at perl-Params-Util.  It doesn't really need
perl-Test-MinimumVersion, only uses it in one part of its test suite (t/99_pmv).
 If the module is not installed then the test is skipped automatically.  So you
can just remove this BuildRequires dependency from perl-Params-Util.spec.
Comment 1 Ralf Corsepius 2008-02-05 09:15:07 EST
We build perl incrementally, so I don't see which bug removing this dep would fix.
Comment 2 Ed Avis 2008-02-05 09:45:42 EST
I came across the dependency cycle while upgrading perl to 5.10, which involves
rebuilding the perl RPM and all the modules.  I expect you will hit the same
thing when you go to 5.10, unless you have some special magic.

In general it seems like a good thing to make sure you don't already need a
package installed in order to build that package.  It's unavoidable for some
essential things like gcc or the shell, but here it's easily avoidable.  There
is no ill effect from removing the BuildRequires line.  So I think it's worth
fixing even if technically you do not consider circular deps to be a bug.
Comment 3 Tom "spot" Callaway 2008-02-05 19:23:08 EST
A lot of packages have been rebuilt against perl 5.10 in the dist-f9-perl tag.
This is part of the plan to merge 5.10 into Fedora 9 (see:
http://fedoraproject.org/wiki/Features/Perl510 )

Specifically, the packages you've pointed out have already been rebuilt. I just
temporarily disabled the tests and the BuildRequires, rebuilt, then rebuilt
again when the BR were done.

Static repo of what has been built already is here:
http://koji.fedoraproject.org/static-repos/dist-f9-perl-build-current/
Comment 4 Ed Avis 2008-02-06 05:27:51 EST
>Specifically, the packages you've pointed out have already been rebuilt. I just
>temporarily disabled the tests and the BuildRequires, rebuilt, then rebuilt
>again when the BR were done.

Hmm... if the BuildRequires are not actually needed to build the package (which
is evidently true, since you built it without them) then surely they should not
be marked as BuildRequires?  They are just nice-to-have packages which may
enable some extra tests to run, but the resulting package builds perfectly
either way.

(If having the full test suite is important, you could still do the
build-install-rebuild cycle as at present, since the tests automatically turn
themselves on if the other modules are present.  But it would no longer be
necessary to manually comment and uncomment the not-really-required
BuildRequires lines, which seems a bit of a charade.)

Thanks for the link to what you've built so far.
Comment 5 Bug Zapper 2008-05-14 01:00:24 EDT
Changing version to '9' as part of upcoming Fedora 9 GA.
More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 6 Bug Zapper 2009-06-09 19:29:54 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 7 Ed Avis 2009-06-12 11:40:04 EDT
Closing this since it's not really a bug, just a philosophical issue.  I still believe that putting in circular build deps is a bad idea (especially so if you then have to manually comment and uncomment them in order to build the packages) but it is best discussed on the mailing list.

Note You need to log in before you can comment on or make changes to this bug.